Imputing_data_CMI_setting2<-function(NN, x_std, x.1.score, x.2.score, x.3.score){
  
  x.3.score.hat<-t(cov(x.3.score[1:NN[1],],cbind(x.1.score[1:NN[1],],x.2.score[1:NN[1],])) %*% 
                     solve(var(cbind(x.1.score[1:NN[1],],x.2.score[1:NN[1],]))) %*% 
                     t(cbind(x.1.score[(NN[1]+1):sum(NN[1:2]),],x.2.score[(NN[1]+1):sum(NN[1:2]),])))
  x.2.score.hat<-t(cov(x.2.score[1:NN[1],],cbind(x.1.score[1:NN[1],],x.3.score[1:NN[1],])) %*% 
                     solve(var(cbind(x.1.score[1:NN[1],],x.3.score[1:NN[1],]))) %*% 
                     t(cbind(x.1.score[(sum(NN[1:2])+1):sum(NN[1:3]),],x.3.score[(NN[1]+1):(NN[1]+NN[3]),])))
  x.1.score.hat<-t(cov(x.1.score[1:NN[1],],cbind(x.2.score[1:NN[1],],x.3.score[1:NN[1],])) %*% 
                     solve(var(cbind(x.2.score[1:NN[1],],x.3.score[1:NN[1],]))) %*% 
                     t(cbind(x.2.score[(sum(NN[1:2])+1):(sum(NN[1:2])+NN[4]),],x.3.score[(NN[1]+NN[3]+1):(NN[1]+sum(NN[3:4])),])))
  x.23.score.hat<-t(cov(cbind(x.2.score[1:NN[1],],x.3.score[1:NN[1],]),x.1.score[1:NN[1],]) %*% 
                      solve(var(x.1.score[1:NN[1],])) %*% 
                      t(x.1.score[(sum(NN[1:3])+1):(sum(NN[1:3])+NN[5]),]))
  x.13.score.hat<-t(cov(cbind(x.1.score[1:NN[1],],x.3.score[1:NN[1],]),x.2.score[1:NN[1],]) %*% 
                      solve(var(x.2.score[1:NN[1],])) %*% 
                      t(x.2.score[(sum(NN[1:2])+NN[4]+1):(sum(NN[1:2])+NN[4]+NN[6]),]))
  x.12.score.hat<-t(cov(cbind(x.1.score[1:NN[1],],x.2.score[1:NN[1],]),x.3.score[1:NN[1],]) %*% 
                      solve(var(x.3.score[1:NN[1],])) %*% 
                      t(x.3.score[(NN[1]+sum(NN[3:4])+1):(NN[1]+sum(NN[3:4])+NN[7]),]))
  
  x.1.score_NA<-rbind(x.1.score[1:sum(NN[1:3]),],
                      x.1.score.hat,
                      x.1.score[(sum(NN[1:3])+1):(sum(NN[1:3])+NN[5]),],
                      x.13.score.hat[,1:k1],
                      x.12.score.hat[,1:k1])
  x.2.score_NA<-rbind(x.2.score[1:sum(NN[1:2]),],
                      x.2.score.hat,
                      x.2.score[(sum(NN[1:2])+1):(sum(NN[1:2])+NN[4]),],
                      x.23.score.hat[,1:k2],
                      x.2.score[(sum(NN[1:2])+NN[4]+1):(sum(NN[1:2])+NN[4]+NN[6]),],
                      x.12.score.hat[,(k2+1):(k1+k2)])
  x.3.score_NA<-rbind(x.3.score[1:NN[1],],
                      x.3.score.hat,
                      x.3.score[(NN[1]+1):(NN[1]+sum(NN[3:4])),],
                      x.23.score.hat[,(k2+1):(k2+k3)],
                      x.13.score.hat[,(k1+1):(k1+k3)],
                      x.3.score[(NN[1]+sum(NN[3:4])+1):(NN[1]+sum(NN[3:4])+NN[7]),])
  
  
  n_iter = 5
  for(j in 1:n_iter)
  {
    x.3.score.hat<-t(cov(x.3.score_NA,cbind(x.1.score_NA,x.2.score_NA)) %*% 
                       solve(var(cbind(x.1.score_NA,x.2.score_NA))) %*% 
                       t(cbind(x.1.score_NA,x.2.score_NA)[(NN[1]+1):sum(NN[1:2]),]))
    
    x.2.score.hat<-t(cov(x.2.score_NA,cbind(x.1.score_NA,x.3.score_NA)) %*% 
                       solve(var(cbind(x.1.score_NA,x.3.score_NA))) %*% 
                       t(cbind(x.1.score_NA,x.3.score_NA)[(sum(NN[1:2])+1):sum(NN[1:3]),]))
    
    x.1.score.hat<-t(cov(x.1.score_NA,cbind(x.2.score_NA,x.3.score_NA)) %*% 
                       solve(var(cbind(x.2.score_NA,x.3.score_NA))) %*% 
                       t(cbind(x.2.score_NA,x.3.score_NA)[(sum(NN[1:3])+1):sum(NN[1:4]),]))
    
    x.23.score.hat<-t(cov(cbind(x.2.score_NA,x.3.score_NA),x.1.score_NA) %*% 
                        solve(var(x.1.score_NA)) %*% 
                        t(x.1.score_NA[(sum(NN[1:4])+1):sum(NN[1:5]),]))
    
    x.13.score.hat<-t(cov(cbind(x.1.score_NA,x.3.score_NA),x.2.score_NA) %*% 
                        solve(var(x.2.score_NA)) %*% 
                        t(x.2.score_NA[(sum(NN[1:5])+1):sum(NN[1:6]),]))
    
    x.12.score.hat<-t(cov(cbind(x.1.score_NA,x.2.score_NA),x.3.score_NA) %*% 
                        solve(var(x.3.score_NA)) %*% 
                        t(x.3.score_NA[(sum(NN[1:6])+1):sum(NN[1:7]),]))
    
    
    x.1.score_NA<-rbind(x.1.score[1:sum(NN[1:3]),],
                        x.1.score.hat,
                        x.1.score[(sum(NN[1:3])+1):(sum(NN[1:3])+NN[5]),],
                        x.13.score.hat[,1:k1],
                        x.12.score.hat[,1:k1])
    x.2.score_NA<-rbind(x.2.score[1:sum(NN[1:2]),],
                        x.2.score.hat,
                        x.2.score[(sum(NN[1:2])+1):(sum(NN[1:2])+NN[4]),],
                        x.23.score.hat[,1:k2],
                        x.2.score[(sum(NN[1:2])+NN[4]+1):(sum(NN[1:2])+NN[4]+NN[6]),],
                        x.12.score.hat[,(k2+1):(k1+k2)])
    x.3.score_NA<-rbind(x.3.score[1:NN[1],],
                        x.3.score.hat,
                        x.3.score[(NN[1]+1):(NN[1]+sum(NN[3:4])),],
                        x.23.score.hat[,(k2+1):(k2+k3)],
                        x.13.score.hat[,(k1+1):(k1+k3)],
                        x.3.score[(NN[1]+sum(NN[3:4])+1):(NN[1]+sum(NN[3:4])+NN[7]),])
  }
  
  return(list(x.1.score_NA, x.2.score_NA, x.3.score_NA))
  
}