Imputing_data_MBI_setting2<-function(NN, x_std, x.1.score_NA, x.2.score_NA, x.3.score_NA){
  
  ### X_{m(2)} = X_{2,3} ###
  
  x.3.score.hat1 = matrix(0,NN[2],k3)
  for(i in 1:k3){
    fit = lm(x.3.score_NA[1:NN[1],i]~., 
             data = as.data.frame(cbind(x.1.score_NA[1:NN[1],],x.2.score_NA[1:NN[1],])))
    x.3.score.hat1[,i] = cbind(rep(1,NN[2]),x.1.score_NA[(NN[1]+1):sum(NN[1:2]),],x.2.score_NA[(NN[1]+1):sum(NN[1:2]),])%*%fit$coefficients
  }
  
  x.3.score.hat2 = matrix(0,NN[2],k3)
  for(i in 1:k3){
    fit = lm(cbind(x.3.score_NA[c(1:NN[1],(sum(NN[1:2])+1):sum(NN[1:3])),i])~., 
                                data = as.data.frame(cbind(x.1.score_NA[c(1:NN[1],(sum(NN[1:2])+1):sum(NN[1:3])),])))
    x.3.score.hat2[,i] = cbind(rep(1,NN[2]),x.1.score_NA[(NN[1]+1):sum(NN[1:2]),])%*%fit$coefficients
  }
  
  x.3.score.hat3 = matrix(0,NN[2],k3)
  for(i in 1:k3){
    fit = lm(cbind(x.3.score_NA[c(1:NN[1],(sum(NN[1:3])+1):sum(NN[1:4])),i])~., 
             data = as.data.frame(cbind(x.2.score_NA[c(1:NN[1],(sum(NN[1:3])+1):sum(NN[1:4])),])))
    x.3.score.hat3[,i] = cbind(rep(1,NN[2]),x.2.score_NA[(NN[1]+1):sum(NN[1:2]),])%*%fit$coefficients
  }
  
  x.3.score_NA[(NN[1]+1):sum(NN[1:2]),] = 
    (x.3.score.hat1 + x.3.score.hat2 + x.3.score.hat3) / 3
  
  
  ### X_{m(3)} = X_{3,2} ###
  
  x.2.score.hat1 = matrix(0,NN[3],k2)
  for(i in 1:k2){
    fit = lm(x.2.score_NA[1:NN[1],i]~., 
             data = as.data.frame(cbind(x.1.score_NA[1:NN[1],],x.3.score_NA[1:NN[1],])))
    x.2.score.hat1[,i] = cbind(rep(1,NN[3]),x.1.score_NA[(sum(NN[1:2])+1):sum(NN[1:3]),],x.3.score_NA[(sum(NN[1:2])+1):sum(NN[1:3]),])%*%fit$coefficients
  }
  
  x.2.score.hat2 = matrix(0,NN[3],k2)
  for(i in 1:k2){
    fit = lm(cbind(x.2.score_NA[1:sum(NN[1:2]),i])~., 
             data = as.data.frame(cbind(x.1.score_NA[1:sum(NN[1:2]),])))
    x.2.score.hat2[,i] = cbind(rep(1,NN[3]),x.1.score_NA[(sum(NN[1:2])+1):sum(NN[1:3]),])%*%fit$coefficients
  }
  
  x.2.score.hat3 = matrix(0,NN[3],k2)
  for(i in 1:k2){
    fit = lm(cbind(x.2.score_NA[c(1:NN[1],(sum(NN[1:3])+1):sum(NN[1:4])),i])~., 
             data = as.data.frame(cbind(x.3.score_NA[c(1:NN[1],(sum(NN[1:3])+1):sum(NN[1:4])),])))
    x.2.score.hat3[,i] = cbind(rep(1,NN[3]),x.3.score_NA[(sum(NN[1:2])+1):sum(NN[1:3]),])%*%fit$coefficients
  }
  
  x.2.score_NA[(sum(NN[1:2])+1):sum(NN[1:3]),] = 
    (x.2.score.hat1 + x.2.score.hat2 + x.2.score.hat3) / 3
  
  
  ### X_{m(4)} = X_{4,1} ###
  
  x.1.score.hat1 = matrix(0,NN[4],k1)
  for(i in 1:k1){
    fit = lm(x.1.score_NA[1:NN[1],i]~., 
             data = as.data.frame(cbind(x.2.score_NA[1:NN[1],],x.3.score_NA[1:NN[1],])))
    x.1.score.hat1[,i] = cbind(rep(1,NN[4]),x.2.score_NA[(sum(NN[1:3])+1):sum(NN[1:4]),],x.3.score_NA[(sum(NN[1:3])+1):sum(NN[1:4]),])%*%fit$coefficients
  }
  
  x.1.score.hat2 = matrix(0,NN[4],k1)
  for(i in 1:k1){
    fit = lm(cbind(x.1.score_NA[1:sum(NN[1:2]),i])~., 
             data = as.data.frame(cbind(x.2.score_NA[1:sum(NN[1:2]),])))
    x.1.score.hat2[,i] = cbind(rep(1,NN[4]),x.2.score_NA[(sum(NN[1:3])+1):sum(NN[1:4]),])%*%fit$coefficients
  }
  
  x.1.score.hat3 = matrix(0,NN[4],k1)
  for(i in 1:k1){
    fit = lm(cbind(x.1.score_NA[c(1:NN[1],(sum(NN[1:2])+1):sum(NN[1:3])),i])~., 
             data = as.data.frame(cbind(x.3.score_NA[c(1:NN[1],(sum(NN[1:2])+1):sum(NN[1:3])),])))
    x.1.score.hat3[,i] = cbind(rep(1,NN[4]),x.3.score_NA[(sum(NN[1:3])+1):sum(NN[1:4]),])%*%fit$coefficients
  }
  
  
  x.1.score.hat = t(cov(x.1.score_NA[c(1:NN[1],(sum(NN[1:2])+1):sum(NN[1:3])),],cbind(x.3.score_NA[c(1:NN[1],(sum(NN[1:2])+1):sum(NN[1:3])),])) %*%
                       solve(var(cbind(x.3.score_NA[c(1:NN[1],(sum(NN[1:2])+1):sum(NN[1:3])),]))) %*% 
                       t(cbind(x.3.score_NA[(sum(NN[1:3])+1):sum(NN[1:4]),])))
  
  
  x.1.score_NA[(sum(NN[1:3])+1):sum(NN[1:4]),] = 
    (x.1.score.hat1 + x.1.score.hat2 + x.1.score.hat3) / 3
  
  
  ### X_{m(5)} = X_{5,2} and x_{5,3} ###
  
  x.23.score.hat = matrix(0,NN[5],(k2+k3))
  for(i in 1:k2){
    fit = lm(cbind(x.2.score_NA[1:NN[1],i])~., 
             data = as.data.frame(cbind(x.1.score_NA[1:NN[1],])))
    x.23.score.hat[,i] = cbind(rep(1,NN[5]),x.1.score_NA[(sum(NN[1:4])+1):sum(NN[1:5]),])%*%fit$coefficients
  }
  
  for(i in 1:k3){
    fit = lm(cbind(x.3.score_NA[1:NN[1],i])~., 
             data = as.data.frame(cbind(x.1.score_NA[1:NN[1],])))
    x.23.score.hat[,(k2+i)] = cbind(rep(1,NN[5]),x.1.score_NA[(sum(NN[1:4])+1):sum(NN[1:5]),])%*%fit$coefficients
  }
  
  x.2.score_NA[(sum(NN[1:4])+1):sum(NN[1:5]),] = x.23.score.hat[,1:k2]
  x.3.score_NA[(sum(NN[1:4])+1):sum(NN[1:5]),] = x.23.score.hat[,(k2+1):(k2+k3)]
  
  
  ### X_{m(6)} = X_{6,1} and x_{6,3} ###
  
  x.13.score.hat = matrix(0,NN[6],(k1+k3))
  for(i in 1:k1){
    fit = lm(cbind(x.1.score_NA[1:NN[1],i])~., 
             data = as.data.frame(cbind(x.2.score_NA[1:NN[1],])))
    x.13.score.hat[,i] = cbind(rep(1,NN[6]),x.2.score_NA[(sum(NN[1:5])+1):sum(NN[1:6]),])%*%fit$coefficients
  }
  
  for(i in 1:k3){
    fit = lm(cbind(x.3.score_NA[1:NN[1],i])~., 
             data = as.data.frame(cbind(x.2.score_NA[1:NN[1],])))
    x.13.score.hat[,(k1+i)] = cbind(rep(1,NN[6]),x.2.score_NA[(sum(NN[1:5])+1):sum(NN[1:6]),])%*%fit$coefficients
  }
  
  x.1.score_NA[(sum(NN[1:5])+1):sum(NN[1:6]),] = x.13.score.hat[,1:k1]
  x.3.score_NA[(sum(NN[1:5])+1):sum(NN[1:6]),] = x.13.score.hat[,(k1+1):(k1+k3)]
  
  
  ### X_{m(7)} = X_{7,1} and x_{7,2} ###
  
  x.12.score.hat = matrix(0,NN[7],(k1+k2))
  for(i in 1:k1){
    fit = lm(cbind(x.1.score_NA[1:NN[1],i])~., 
             data = as.data.frame(cbind(x.3.score_NA[1:NN[1],])))
    x.12.score.hat[,i] = cbind(rep(1,NN[7]),x.3.score_NA[(sum(NN[1:6])+1):sum(NN[1:7]),])%*%fit$coefficients
  }
  
  for(i in 1:k2){
    fit = lm(cbind(x.2.score_NA[1:NN[1],i])~., 
             data = as.data.frame(cbind(x.3.score_NA[1:NN[1],])))
    x.12.score.hat[,(k1+i)] = cbind(rep(1,NN[7]),x.3.score_NA[(sum(NN[1:6])+1):sum(NN[1:7]),])%*%fit$coefficients
  }
  
  x.1.score_NA[(sum(NN[1:6])+1):sum(NN[1:7]),] = x.12.score.hat[,1:k1]
  x.2.score_NA[(sum(NN[1:6])+1):sum(NN[1:7]),] = x.12.score.hat[,(k1+1):(k1+k2)]
  
  
  return(list(x.1.score_NA, x.2.score_NA, x.3.score_NA))
  
}