Construct_factor_PCA = function(x_std, psi.1.hat, psi.2.hat, x.1.score_NA, x.2.score_NA){
  
  score<-cbind(x.1.score_NA,x.2.score_NA)
  z.hat<-t(score) %*% score /(N-1)
  
  rho.hat_std_temp<-x.1.score_NA%*% eigen(z.hat)$vec[1:k1,1:(k1+k2)] + x.2.score_NA%*% eigen(z.hat)$vec[(k1+1):(k1+k2),1:(k1+k2)]  ### Estimated MFPC scores with order N*(k1+k2) based on the correlation matrix
  x.hat_std<-rho.hat_std_temp %*% cbind(psi.1.hat,psi.2.hat)
  
  rho.hat_std<-scale(rho.hat_std_temp)[,1:M0]
  
  x_std[(sum(NN[1:2])+1):N,1:T1]<-x.hat_std[(sum(NN[1:2])+1):N,1:T1]
  x_std[(NN[1]+1):sum(NN[1:2]),(T1+1):(T1+T2)]<-x.hat_std[(NN[1]+1):sum(NN[1:2]),(T1+1):(T1+T2)]
  
  return(list(rho.hat_std, x_std))
  
}